<?php

namespace SMSPins;

class APIClient
{
     public $api_key;
     public $api_url;
     public $endpoint;
     public function __construct($api_key,$endpoint,$api_url)
     {
          $this->api_key      = $api_key;
          $this->endpoint     = $endpoint;
          $this->api_url      = rtrim($api_url,'/');
     }
     protected function _get($params=array())
     {
          $is_post  = false;
          $trace    = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 2);
          $verb     = $trace[count($trace) - 1]['function'];

          return $this->_request($verb, $is_post, $params);
     }
     protected function _post($params=array())
     {
          $is_post  = true;
          $trace    = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 2);
          $verb     = $trace[count($trace) - 1]['function'];

          return $this->_request($verb, $is_post, $params);
     }
     protected function _request($verb, $is_post, $params)
     {
          $aUrlParts     = array();
          if ( !$is_post ) {//If its HTTP GET Request
               foreach( $params as $param ) {
                    if ($param) {
                         $aUrlParts[]   = $param;
                    }
               }
          }
          $url_part = implode('/', $aUrlParts);
          if ( $url_part ) {
               $url_part = '/' . $url_part;
          }
          $url      = $this->api_url . '/' . $this->api_key . '/' . $this->endpoint . '/' . $verb . $url_part;
          $this->_ch = curl_init();
          curl_setopt( $this->_ch, CURLOPT_URL, $url );
          if ($is_post) {
               $params['token']    = $this->api_key;
               $params['action']   = $verb;
               $params_json        = json_encode($params);
               curl_setopt($this->_ch, CURLOPT_POST, true);
               curl_setopt($this->_ch, CURLOPT_POSTFIELDS, $params_json);
               curl_setopt( $this->_ch, CURLOPT_HTTPHEADER, array( 'Content-Type: application/json', 'Content-Length: ' . strlen($params_json) ) );
          } else {
               curl_setopt( $this->_ch, CURLOPT_HTTPHEADER, array( 'Content-Type: application/json' ) );
          }
          
          curl_setopt( $this->_ch, CURLOPT_RETURNTRANSFER, true );
          $response = curl_exec( $this->_ch );
          
          $json     = json_decode( $response );
          return $json;

     }
}