<?php
namespace SMSPins\APIClient\BulkSMS;


use SMSPins;

class BulkSMSClient extends SMSPins\APIClient
{
     public function __construct($api_key,$api_url)
     {
          parent::__construct($api_key,'bulk_sms',$api_url);
     }
     
     public function telephones()
     {
          return $this->_get();
     }
     public function request($telephone_id)
     {
          return $this->_get(array($telephone_id));
     }
     public function status($request_id)
     {
          return $this->_get(array($request_id));
     }
     public function cancel($request_id)
     {
          return $this->_get(array($request_id));
     }
     public function smses_by_tid($telephone_id)
     {
          return $this->_get(array($telephone_id));
     }
     public function autocheck($telephone_id,$action)
     {
          return $this->_get(array($telephone_id,$action));
     }
     public function enable_autocheck($telephone_id)
     {
          return $this->autocheck($telephone_id,'enable');
     }
     public function disable_autocheck($telephone_id)
     {
          return $this->autocheck($telephone_id,'disable');
     }
}

class NCClient extends SMSPins\APIClient
{
     public function __construct($api_key,$api_url)
     {
          parent::__construct($api_key,'nc',$api_url);
     }
     
     public function requests()
     {
          return $this->_get();
     }
     public function request($telephone_id)
     {
          return $this->_get(array($telephone_id));
     }
     public function status($request_id)
     {
          return $this->_get(array($request_id));
     }
     public function cancel($request_id)
     {
          return $this->_get(array($request_id));
     }
}
